import random

import uwuify

leet_map = {'a': '4', 'e': '3', 'i': '1', 'o': '0', 's': '5', 't': '7'}

def uwu(text: str) -> str:
    return uwuify.uwu(text)

def gibberish(text: str) -> str:
    return " ".join(["".join(
        random.sample(word, len(word)))
        for word in text.split()
    ])

def leet(text: str) -> str:
    return "".join([
        leet_map.get(char.lower(), char)
        for char in text
    ])

def reverse(text: str) -> str:
    return text[::-1]

def shuffle(text: str) -> str:
    words = text.split()
    random.shuffle(words)
    return " ".join(words)

def _pig_latin_word(word: str) -> str:
    first_vowel = 0
    for char in word:
        if char in "aeiou":
            break

        first_vowel += 1

    if first_vowel == 0:
        return word + "way"

    else:
        return word[first_vowel:] + word[:first_vowel] + "ay"

def pig_latin(text: str) -> str:
    return " ".join([_pig_latin_word(word) for word in text.split()])

def random_case(text: str) -> str:
    return "".join([
        char.upper() if random.random() > 0.5 else char.lower()
        for char in text
    ])